/** Header file generated with fdesign on Sun Jan 21 16:09:54 2001.**/

#ifndef FD_form_h_
#define FD_form_h_

/** Callbacks, globals and object handlers **/
extern void zoomdial_cb(FL_OBJECT *, long);
extern void reset_zoom(FL_OBJECT *, long);
extern void autorot_button_cb(FL_OBJECT *, long);
extern void toggle_lights(FL_OBJECT *, long);
extern void brightnessdial_cb(FL_OBJECT *, long);
extern void reset_brightness(FL_OBJECT *, long);
extern void toggle_hilights(FL_OBJECT *, long);
extern void toggle_box_cb(FL_OBJECT *, long);
extern void toggle_constrained_scaling(FL_OBJECT *, long);
extern void invert_speed_data(FL_OBJECT *, long);
extern void show_about_form(FL_OBJECT *, long);

extern void hide_about_form(FL_OBJECT *, long);


/**** Forms and Objects ****/
typedef struct {
	FL_FORM *form;
	void *vdata;
	char *cdata;
	long  ldata;
	FL_OBJECT *zoomdial;
	FL_OBJECT *nodecount_box;
	FL_OBJECT *framespeed_box;
	FL_OBJECT *glCanvas;
	FL_OBJECT *file_menu;
	FL_OBJECT *style_menu;
	FL_OBJECT *view_menu;
	FL_OBJECT *options_menu;
	FL_OBJECT *autorot_button;
	FL_OBJECT *light_button;
	FL_OBJECT *brightnessdial;
	FL_OBJECT *shading_menu;
	FL_OBJECT *hilight_button;
	FL_OBJECT *toggle_box_button;
	FL_OBJECT *constrained_scaling_button;
	FL_OBJECT *framecounters;
	FL_OBJECT *framecounterbutton;
} FD_form;

extern FD_form * create_form_form(void);
typedef struct {
	FL_FORM *about;
	void *vdata;
	char *cdata;
	long  ldata;
	FL_OBJECT *text;
} FD_about;

extern FD_about * create_form_about(void);

#endif /* FD_form_h_ */
