const char gl2ps_prolog[] = 
"/BD { bind def } bind def\n"
"/C  { setrgbcolor } BD\n"
"/G  { setgray } BD\n"
"/P  { newpath 0.0 360.0 arc closepath fill } BD		% point\n"
"/L  { newpath moveto lineto stroke } BD			% line\n"
"/T  { newpath moveto lineto lineto closepath fill } BD	% triangle\n"
"/W  { setlinewidth } BD\n"
"/FC { findfont exch scalefont setfont } BD\n"
"/S  { FC moveto show } BD\n"
"\n"
"% weights attached to red, green, blue components, a la xv\n"
"/rw 20 def\n"
"/gw 32 def\n"
"/bw 12 def\n"
"/reps smoothness rw div def\n"
"/geps smoothness gw div def\n"
"/beps smoothness bw div def\n"
"\n"
"/GL {	% draw a gradually shaded gray line\n"
"	% x1 y1 c1 x2 y2 c2 GL\n"
"\n"
"	/c2 exch def\n"
"	/y2 exch def\n"
"	/x2 exch def\n"
"\n"
"	/c1 exch def\n"
"	/y1 exch def\n"
"	/x1 exch def\n"
"\n"
"	c1 c2 sub abs geps gt\n"
"	{\n"
"\n"
"		/c12 c1 c2 add 2 div def\n"
"		/y12 y1 y2 add 2 div def\n"
"		/x12 x1 x2 add 2 div def\n"
"\n"
"		x1 y1 c1\n"
"		x12 y12 c12\n"
"\n"
"		x2 y2 c2\n"
"		x12 y12 c12\n"
"\n"
"		GL GL\n"
"	} {\n"
"		c1 G x1 y1 x2 y2 L\n"
"	} ifelse\n"
"} def\n"
"\n"
"/CL {	% draws a gradually shaded rgb color line\n"
"	% x1 y1 r1 g1 b1 x2 y2 r2 g2 b2 CL\n"
"\n"
"	/b2 exch def\n"
"	/g2 exch def\n"
"	/r2 exch def\n"
"	/y2 exch def\n"
"	/x2 exch def\n"
"\n"
"	/b1 exch def\n"
"	/g1 exch def\n"
"	/r1 exch def\n"
"	/y1 exch def\n"
"	/x1 exch def\n"
"\n"
"	b1 b2 sub abs beps gt\n"
"	g1 g2 sub abs geps gt\n"
"	r1 r2 sub abs reps gt\n"
"\n"
"	or or {\n"
"\n"
"		/b12 b1 b2 add 2 div def\n"
"		/g12 g1 g2 add 2 div def\n"
"		/r12 r1 r2 add 2 div def\n"
"		/y12 y1 y2 add 2 div def\n"
"		/x12 x1 x2 add 2 div def\n"
"\n"
"		x1 y1 r1 g1 b1\n"
"		x12 y12 r12 g12 b12\n"
"\n"
"		x2 y2 r2 g2 b2\n"
"		x12 y12 r12 g12 b12\n"
"\n"
"		CL CL\n"
"	} {\n"
"		r1 g1 b1 C x1 y1 x2 y2 L\n"
"	} ifelse\n"
"} def\n"
"\n"
"/GTnoshfill {	% draws a gradually-shaded gray triangle using LL2 features only\n"
"		% x1 y1 c1 x2 y2 c2 x3 y3 c3 GTnoshfill\n"
"\n"
"	/c3 exch def\n"
"	/y3 exch def\n"
"	/x3 exch def\n"
"\n"
"	/c2 exch def\n"
"	/y2 exch def\n"
"	/x2 exch def\n"
"\n"
"	/c1 exch def\n"
"	/y1 exch def\n"
"	/x1 exch def\n"
"	\n"
"	c1 c2 sub abs geps gt\n"
"	c2 c3 sub abs geps gt\n"
"	c3 c1 sub abs geps gt\n"
"\n"
"	or or {\n"
"\n"
"		/c12 c1 c2 add 2 div def\n"
"		/y12 y1 y2 add 2 div def\n"
"		/x12 x1 x2 add 2 div def\n"
"\n"
"		/c23 c2 c3 add 2 div def\n"
"		/y23 y2 y3 add 2 div def\n"
"		/x23 x2 x3 add 2 div def\n"
"\n"
"		/c31 c3 c1 add 2 div def\n"
"		/y31 y3 y1 add 2 div def\n"
"		/x31 x3 x1 add 2 div def\n"
"\n"
"		x1 y1 c1\n"
"		x12 y12 c12\n"
"		x31 y31 c31\n"
"\n"
"		x2 y2 c2\n"
"		x12 y12 c12\n"
"		x23 y23 c23\n"
"\n"
"		x3 y3 c3\n"
"		x23 y23 c23\n"
"		x31 y31 c31\n"
"\n"
"		x23 y23 c23\n"
"		x12 y12 c12\n"
"		x31 y31 c31\n"
"\n"
"		GTnoshfill GTnoshfill GTnoshfill GTnoshfill\n"
"	} {\n"
"		c1 G x1 y1 x2 y2 x3 y3 T\n"
"	} ifelse\n"
"} def\n"
"\n"
"% CTnoshfill from Christophe Geuzaine's gl2ps library: http://www.geuz.org/gl2ps\n"
"/CTnoshfill {	% draws a Gouraud-shaded gray triangle using LL2 features only\n"
"		% x1 y1 r1 g1 b1 x2 y2 r2 g2 b2 x3 y3 r3 g3 b3 CTnoshfill\n"
"\n"
"	/b1 exch def\n"
"	/g1 exch def\n"
"	/r1 exch def\n"
"	/y1 exch def\n"
"	/x1 exch def\n"
"\n"
"	/b2 exch def\n"
"	/g2 exch def\n"
"	/r2 exch def\n"
"	/y2 exch def\n"
"	/x2 exch def\n"
"\n"
"	/b3 exch def\n"
"	/g3 exch def\n"
"	/r3 exch def\n"
"	/y3 exch def\n"
"	/x3 exch def\n"
"	\n"
"	b1 b2 sub abs beps gt\n"
"	g1 g2 sub abs geps gt\n"
"	r1 r2 sub abs reps gt\n"
"	b2 b3 sub abs beps gt\n"
"	g2 g3 sub abs geps gt\n"
"	r2 r3 sub abs reps gt\n"
"	b3 b1 sub abs beps gt\n"
"	g3 g1 sub abs geps gt\n"
"	r3 r1 sub abs reps gt\n"
"\n"
"	or or or or or or or or {\n"
"\n"
"		/b12 b1 b2 add 2 div def\n"
"		/g12 g1 g2 add 2 div def\n"
"		/r12 r1 r2 add 2 div def\n"
"		/y12 y1 y2 add 2 div def\n"
"		/x12 x1 x2 add 2 div def\n"
"\n"
"		/b13 b1 b3 add 2 div def\n"
"		/g13 g1 g3 add 2 div def\n"
"		/r13 r1 r3 add 2 div def\n"
"		/y13 y1 y3 add 2 div def\n"
"		/x13 x1 x3 add 2 div def\n"
"\n"
"		/b32 b3 b2 add 2 div def\n"
"		/g32 g3 g2 add 2 div def\n"
"		/r32 r3 r2 add 2 div def\n"
"		/y32 y3 y2 add 2 div def\n"
"		/x32 x3 x2 add 2 div def\n"
"	\n"
"		x1 y1 r1 g1 b1\n"
"		x12 y12 r12 g12 b12\n"
"		x13 y13 r13 g13 b13\n"
"\n"
"		x2 y2 r2 g2 b2\n"
"		x12 y12 r12 g12 b12\n"
"		x32 y32 r32 g32 b32\n"
"\n"
"		x3 y3 r3 g3 b3\n"
"		x32 y32 r32 g32 b32\n"
"		x13 y13 r13 g13 b13\n"
"\n"
"		x32 y32 r32 g32 b32\n"
"		x12 y12 r12 g12 b12\n"
"		x13 y13 r13 g13 b13\n"
"\n"
"		CTnoshfill CTnoshfill CTnoshfill CTnoshfill\n"
"	} {\n"
"		r1 g1 b1 C x1 y1 x2 y2 x3 y3 T\n"
"	} ifelse\n"
"} def\n"
"\n"
"/GTshfill {	% draws a Gouraud-shaded gray triangle using LL3's shfill\n"
"		% x1 y1 c1 x2 y2 c2 x3 y3 c3 GTshfill\n"
"\n"
"	/c3 exch def\n"
"	/y3 exch def\n"
"	/x3 exch def\n"
"\n"
"	/c2 exch def\n"
"	/y2 exch def\n"
"	/x2 exch def\n"
"\n"
"	/c1 exch def\n"
"	/y1 exch def\n"
"	/x1 exch def\n"
"\n"
"	<<	/ShadingType 4\n"
"		/ColorSpace /DeviceGray\n"
"		/DataSource [\n"
"			0 x1 y1 c1\n"
"			0 x2 y2 c2\n"
"			0 x3 y3 c3\n"
"		]\n"
"	>> shfill\n"
"} BD\n"
"\n"
"/CTshfill {	% draws a Gouraud-shaded rgb color triangle using LL3's shfill\n"
"		% x1 y1 r1 g1 b1 x2 y2 r2 g2 b2 x3 y3 r3 g3 b3 CTshfill\n"
"\n"
"	/b3 exch def\n"
"	/g3 exch def\n"
"	/r3 exch def\n"
"	/y3 exch def\n"
"	/x3 exch def\n"
"\n"
"	/b2 exch def\n"
"	/g2 exch def\n"
"	/r2 exch def\n"
"	/y2 exch def\n"
"	/x2 exch def\n"
"\n"
"	/b1 exch def\n"
"	/g1 exch def\n"
"	/r1 exch def\n"
"	/y1 exch def\n"
"	/x1 exch def\n"
"\n"
"	<<	/ShadingType 4\n"
"		/ColorSpace /DeviceRGB\n"
"		/DataSource [\n"
"			0 x1 y1 r1 g1 b1\n"
"			0 x2 y2 r2 g2 b2\n"
"			0 x3 y3 r3 g3 b3\n"
"		]\n"
"	>> shfill\n"
"} BD\n"
"\n"
"\n"
"/shfill where {		% if we have shfill, then use it, else simulate\n"
"	pop\n"
"	/CT { CTshfill } BD\n"
"	/GT { GTshfill } BD\n"
"} {\n"
"	/CT { CTnoshfill } BD\n"
"	/GT { GTnoshfill } BD\n"
"} ifelse\n"
"\n"
"end	% close gl2ps dict\n"
"%%EndProlog\n"
;
