
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "grammar.y"


/* uncomment for dubugging
#define YYDEBUG 1
int yydebug = 1;
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "dynagraph.h"
#include "parse.h"

/* local function declarations */
static int  yyerror(char *s);
static char *catargs(char *a, char *b);
static Expr *merge_expr0(char *s);
static Expr *merge_expr1(Expr *e, short int type);
static Expr *merge_expr2(Expr *a, Expr *b, char op);
static Expr *merge_expr3(Expr *e, char *id);
static Expr *merge_expr4(Expr *e1, Expr *e2, char *id);
static PolygonVertex *dg_vertex_tail;

extern char *prognam;

/* Global variables, containing the results of sympolic parsing of the input */
extern Plot3D		*dg_plots;
extern Plot3Dattribs	*dg_attribs;
extern char		*dg_dispargs;
extern Expr3		*dg_vertex;	/* linked list of polygon vertices */



/* Line 189 of yacc.c  */
#line 107 "grammar.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     _DOTS = 258,
     _READ = 259,
     _DUMP = 260,
     _RESTART = 261,
     _SAVEGRAPH = 262,
     _JPEG = 263,
     _TIFF = 264,
     _PPM3 = 265,
     _PPM6 = 266,
     _POSTSCRIPT = 267,
     _COLORPOSTSCRIPT = 268,
     _VECTORPOSTSCRIPT = 269,
     _PNG = 270,
     _ALIGN = 271,
     _LEFT = 272,
     _RIGHT = 273,
     _ABOVE = 274,
     _BELOW = 275,
     _PLOT = 276,
     _DISPLAY = 277,
     _SPACECURVE = 278,
     _TUBEPLOT = 279,
     _POLYGONPLOT = 280,
     _DATAPLOT = 281,
     _TEXTPLOT = 282,
     _GRID = 283,
     _TITLE = 284,
     _LABELS = 285,
     _THICKNESS = 286,
     _POINTSIZE = 287,
     _VIEW = 288,
     _COLOR = 289,
     _CONTOURS = 290,
     _NUMPOINTS = 291,
     _TUBEPOINTS = 292,
     _TUBERADIUS = 293,
     _ORIENTATION = 294,
     _TICKMARKS = 295,
     _COORDS = 296,
     _CARTESIAN = 297,
     _CYLINDRICAL = 298,
     _Z_CYLINDRICAL = 299,
     _SPHERICAL = 300,
     _GRIDSTYLE = 301,
     _TRIANGULAR_GRIDLINES = 302,
     _XY_GRIDLINES = 303,
     _X_GRIDLINES = 304,
     _Y_GRIDLINES = 305,
     _STYLE = 306,
     _POINT = 307,
     _HIDDEN = 308,
     _PATCH = 309,
     _WIREFRAME = 310,
     _CONTOUR = 311,
     _PATCHNOGRID = 312,
     _PATCHCONTOUR = 313,
     _SCALING = 314,
     _CONSTRAINED = 315,
     _UNCONSTRAINED = 316,
     _AXES = 317,
     _BOXED = 318,
     _NORMAL = 319,
     _FRAME = 320,
     _NONE = 321,
     _SHADING = 322,
     _XYZ = 323,
     _XY = 324,
     _Z = 325,
     _ZGRAYSCALE = 326,
     _ZHUE = 327,
     _AXESFONT = 328,
     _FONT = 329,
     _LABELFONT = 330,
     _TITLEFONT = 331,
     _TIMES = 332,
     _COURIER = 333,
     _HELVETICA = 334,
     _SYMBOL = 335,
     _ROMAN = 336,
     _BOLD = 337,
     _ITALIC = 338,
     _BOLDITALIC = 339,
     _OBLIQUE = 340,
     _BOLDOBLIQUE = 341,
     _NUMBER = 342,
     _IDENT = 343,
     _STRING = 344,
     UPLUS = 345,
     UMINUS = 346
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 34 "grammar.y"

	char			*str;
	Range			*rspec;
	unsigned int		fspec;
	Expr			*e;
	Expr3			*e3;
	enum PLOTOUT_FORMAT	fmt;
	SavegraphData		*sgd;
	PolygonVertex		*pvp;



/* Line 214 of yacc.c  */
#line 247 "grammar.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 259 "grammar.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   517

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  107
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  88
/* YYNRULES -- Number of rules.  */
#define YYNRULES  214
/* YYNRULES -- Number of states.  */
#define YYNSTATES  433

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   346

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     100,   101,    93,    91,    90,    92,     2,    94,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    99,    98,
       2,   102,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   103,     2,   104,    95,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   105,     2,   106,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    96,    97
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     4,     7,    11,    15,    19,    23,    27,
      31,    35,    39,    43,    47,    51,    55,    59,    63,    67,
      71,    75,    79,    83,    87,    89,    91,    94,    99,   104,
     111,   113,   115,   117,   119,   121,   123,   125,   127,   132,
     138,   140,   144,   146,   148,   150,   152,   154,   156,   158,
     160,   162,   164,   166,   168,   170,   172,   174,   176,   178,
     180,   182,   184,   186,   188,   190,   192,   200,   208,   218,
     222,   223,   224,   225,   238,   242,   246,   250,   252,   254,
     256,   258,   262,   264,   266,   268,   270,   272,   274,   278,
     280,   282,   284,   286,   288,   290,   292,   296,   300,   302,
     304,   306,   308,   312,   314,   316,   318,   320,   324,   326,
     328,   330,   332,   336,   338,   340,   346,   362,   366,   370,
     374,   378,   382,   386,   390,   394,   402,   410,   416,   424,
     430,   436,   438,   440,   442,   444,   446,   448,   450,   452,
     454,   456,   461,   466,   471,   476,   481,   486,   492,   496,
     498,   500,   504,   506,   510,   512,   514,   518,   523,   525,
     529,   533,   535,   539,   543,   548,   553,   557,   561,   563,
     565,   569,   571,   575,   579,   584,   589,   591,   595,   597,
     599,   603,   607,   609,   613,   615,   620,   625,   627,   631,
     633,   638,   640,   644,   646,   648,   652,   656,   658,   662,
     672,   678,   680,   682,   684,   686,   689,   692,   696,   700,
     704,   708,   712,   716,   721
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     108,     0,    -1,    -1,   108,   109,    -1,   108,   110,   109,
      -1,   108,   111,   109,    -1,   108,    88,   109,    -1,   108,
       5,   109,    -1,   108,     6,   109,    -1,   108,   113,   109,
      -1,   108,   156,   109,    -1,   108,   176,   109,    -1,   108,
     169,   109,    -1,   108,   168,   109,    -1,   108,   163,   109,
      -1,   108,   186,   109,    -1,   108,   183,   109,    -1,   108,
     155,    98,    -1,   108,   155,    99,    -1,   108,   175,    98,
      -1,   108,   175,    99,    -1,   108,   182,    98,    -1,   108,
     182,    99,    -1,   108,     1,   109,    -1,    98,    -1,    99,
      -1,     4,   193,    -1,     4,   100,   193,   101,    -1,     7,
     100,   112,   101,    -1,     7,   100,   112,    90,   193,   101,
      -1,     8,    -1,     9,    -1,    15,    -1,    10,    -1,    11,
      -1,    12,    -1,    13,    -1,    14,    -1,    88,    99,   102,
     194,    -1,    88,   102,   194,     3,   194,    -1,   116,    -1,
     115,    90,   116,    -1,   117,    -1,   118,    -1,   119,    -1,
     120,    -1,   121,    -1,   125,    -1,   126,    -1,   127,    -1,
     129,    -1,   131,    -1,   133,    -1,   134,    -1,   136,    -1,
     140,    -1,   147,    -1,   148,    -1,   149,    -1,   150,    -1,
     143,    -1,   144,    -1,   145,    -1,   146,    -1,   142,    -1,
     138,    -1,    28,   102,   103,   194,    90,   194,   104,    -1,
      39,   102,   103,   194,    90,   194,   104,    -1,    40,   102,
     103,    87,    90,    87,    90,    87,   104,    -1,    29,   102,
     193,    -1,    -1,    -1,    -1,    30,   102,   103,   193,   122,
      90,   193,   123,    90,   193,   124,   104,    -1,    31,   102,
      87,    -1,    32,   102,    87,    -1,    41,   102,   128,    -1,
      42,    -1,    43,    -1,    44,    -1,    45,    -1,    67,   102,
     130,    -1,    68,    -1,    69,    -1,    70,    -1,    71,    -1,
      72,    -1,    66,    -1,    51,   102,   132,    -1,    52,    -1,
      53,    -1,    54,    -1,    55,    -1,    56,    -1,    57,    -1,
      58,    -1,    34,   102,   193,    -1,    46,   102,   135,    -1,
      48,    -1,    49,    -1,    50,    -1,    47,    -1,    62,   102,
     137,    -1,    63,    -1,    64,    -1,    65,    -1,    66,    -1,
      16,   102,   139,    -1,    17,    -1,    18,    -1,    19,    -1,
      20,    -1,    59,   102,   141,    -1,    60,    -1,    61,    -1,
      33,   102,   194,     3,   194,    -1,    33,   102,   103,   194,
       3,   194,    90,   194,     3,   194,    90,   194,     3,   194,
     104,    -1,    36,   102,   194,    -1,    35,   102,   194,    -1,
      37,   102,   194,    -1,    38,   102,   194,    -1,    73,   102,
     151,    -1,    74,   102,   151,    -1,    75,   102,   151,    -1,
      76,   102,   151,    -1,   103,    77,    90,   152,    90,    87,
     104,    -1,   103,    78,    90,   153,    90,    87,   104,    -1,
     103,    78,    90,    87,   104,    -1,   103,    79,    90,   154,
      90,    87,   104,    -1,   103,    79,    90,    87,   104,    -1,
     103,    80,    90,    87,   104,    -1,    81,    -1,    82,    -1,
      83,    -1,    84,    -1,    82,    -1,    85,    -1,    86,    -1,
      82,    -1,    85,    -1,    86,    -1,    88,    99,   102,   156,
      -1,    88,    99,   102,   169,    -1,    88,    99,   102,   168,
      -1,    88,    99,   102,   163,    -1,    88,    99,   102,   186,
      -1,    21,   100,   157,   101,    -1,   158,    90,   114,    90,
     114,    -1,   157,    90,   115,    -1,   161,    -1,   159,    -1,
     105,   160,   106,    -1,   161,    -1,   160,    90,   161,    -1,
     162,    -1,   194,    -1,   103,   192,   104,    -1,    25,   100,
     164,   101,    -1,   165,    -1,   165,    90,   115,    -1,   103,
     166,   104,    -1,   167,    -1,   166,    90,   167,    -1,   103,
     192,   104,    -1,    24,   100,   170,   101,    -1,    23,   100,
     170,   101,    -1,   171,    90,   114,    -1,   170,    90,   115,
      -1,   174,    -1,   172,    -1,   105,   173,   106,    -1,   174,
      -1,   173,    90,   174,    -1,   103,   192,   104,    -1,    88,
      99,   102,   176,    -1,    22,   100,   177,   101,    -1,   178,
      -1,   177,    90,   115,    -1,   181,    -1,   179,    -1,   105,
     180,   106,    -1,   103,   180,   104,    -1,   181,    -1,   180,
      90,   181,    -1,    88,    -1,    88,    99,   102,   183,    -1,
      26,   100,   184,   101,    -1,   185,    -1,   184,    90,   115,
      -1,   193,    -1,    27,   100,   187,   101,    -1,   188,    -1,
     187,    90,   115,    -1,   191,    -1,   189,    -1,   105,   190,
     106,    -1,   103,   190,   104,    -1,   191,    -1,   190,    90,
     191,    -1,   103,   194,    90,   194,    90,   194,    90,   193,
     104,    -1,   194,    90,   194,    90,   194,    -1,    89,    -1,
      88,    -1,    87,    -1,    88,    -1,    92,   194,    -1,    91,
     194,    -1,   194,    91,   194,    -1,   194,    92,   194,    -1,
     194,    93,   194,    -1,   194,    94,   194,    -1,   194,    95,
     194,    -1,   100,   194,   101,    -1,    88,   100,   194,   101,
      -1,    88,   100,   194,    90,   194,   101,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,    79,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   103,   104,   107,   108,   112,   116,
     122,   123,   124,   125,   126,   127,   128,   129,   132,   138,
     145,   146,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   175,   180,   185,   192,
     196,   197,   198,   195,   201,   214,   227,   230,   231,   232,
     233,   236,   240,   241,   242,   243,   244,   245,   248,   251,
     252,   253,   254,   255,   256,   257,   260,   263,   266,   267,
     268,   269,   272,   275,   276,   277,   278,   281,   284,   285,
     286,   287,   290,   293,   295,   299,   302,   311,   314,   317,
     320,   323,   327,   331,   335,   339,   341,   343,   345,   347,
     349,   353,   354,   355,   356,   359,   360,   361,   364,   365,
     366,   369,   370,   371,   372,   373,   376,   379,   382,   385,
     386,   389,   392,   393,   405,   417,   422,   427,   431,   432,
     435,   443,   444,   450,   456,   462,   465,   466,   469,   470,
     473,   476,   477,   489,   500,   503,   506,   507,   510,   511,
     514,   515,   518,   519,   522,   530,   534,   537,   538,   541,
     546,   549,   550,   553,   554,   557,   558,   561,   562,   565,
     583,   591,   592,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "_DOTS", "_READ", "_DUMP", "_RESTART",
  "_SAVEGRAPH", "_JPEG", "_TIFF", "_PPM3", "_PPM6", "_POSTSCRIPT",
  "_COLORPOSTSCRIPT", "_VECTORPOSTSCRIPT", "_PNG", "_ALIGN", "_LEFT",
  "_RIGHT", "_ABOVE", "_BELOW", "_PLOT", "_DISPLAY", "_SPACECURVE",
  "_TUBEPLOT", "_POLYGONPLOT", "_DATAPLOT", "_TEXTPLOT", "_GRID", "_TITLE",
  "_LABELS", "_THICKNESS", "_POINTSIZE", "_VIEW", "_COLOR", "_CONTOURS",
  "_NUMPOINTS", "_TUBEPOINTS", "_TUBERADIUS", "_ORIENTATION", "_TICKMARKS",
  "_COORDS", "_CARTESIAN", "_CYLINDRICAL", "_Z_CYLINDRICAL", "_SPHERICAL",
  "_GRIDSTYLE", "_TRIANGULAR_GRIDLINES", "_XY_GRIDLINES", "_X_GRIDLINES",
  "_Y_GRIDLINES", "_STYLE", "_POINT", "_HIDDEN", "_PATCH", "_WIREFRAME",
  "_CONTOUR", "_PATCHNOGRID", "_PATCHCONTOUR", "_SCALING", "_CONSTRAINED",
  "_UNCONSTRAINED", "_AXES", "_BOXED", "_NORMAL", "_FRAME", "_NONE",
  "_SHADING", "_XYZ", "_XY", "_Z", "_ZGRAYSCALE", "_ZHUE", "_AXESFONT",
  "_FONT", "_LABELFONT", "_TITLEFONT", "_TIMES", "_COURIER", "_HELVETICA",
  "_SYMBOL", "_ROMAN", "_BOLD", "_ITALIC", "_BOLDITALIC", "_OBLIQUE",
  "_BOLDOBLIQUE", "_NUMBER", "_IDENT", "_STRING", "','", "'+'", "'-'",
  "'*'", "'/'", "'^'", "UPLUS", "UMINUS", "';'", "':'", "'('", "')'",
  "'='", "'['", "']'", "'{'", "'}'", "$accept", "stmt", "term", "readcmd",
  "savegraphcmd", "savegraphformat", "expr_assign", "range", "optlist",
  "option", "grid", "orientation", "tickmarks", "title", "labels", "$@1",
  "$@2", "$@3", "thickness", "pointsize", "coords", "coordsopt", "shading",
  "shadingopt", "style", "styleopt", "color", "gridstyle", "gridstyleopt",
  "axes", "axesopt", "align", "alignopt", "scaling", "scalingopt", "view",
  "numpoints", "contours", "tubepoints", "tuberadius", "axesfont", "font",
  "labelfont", "titlefont", "fontspec", "times_fontstyle",
  "courier_fontstyle", "helvetica_fontstyle", "plot_assign",
  "plot_command", "plot_fullarg", "plot_arg", "plot_objset", "plot_objseq",
  "plot_obj", "plot_desc", "polygonplot_cmd", "polygonplot_fullarg",
  "vertex_list", "vertex_chain", "vertex", "tubeplot_cmd", "curveplot_cmd",
  "curveplot_fullarg", "curveplot_arg", "curve_objset", "curve_objseq",
  "curve_obj", "disp_assign", "disp_command", "disp_fullarg", "disp_arg",
  "disp_objset", "disp_objseq", "disp_obj", "dataplot_assign",
  "dataplot_cmd", "dataplot_fullarg", "dataplot_arg", "textplot_cmd",
  "textplot_fullarg", "textplot_arg", "textplot_objset", "textplot_objseq",
  "textplot_obj", "expr3", "string_or_ident", "expr", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
      44,    43,    45,    42,    47,    94,   345,   346,    59,    58,
      40,    41,    61,    91,    93,   123,   125
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   107,   108,   108,   108,   108,   108,   108,   108,   108,
     108,   108,   108,   108,   108,   108,   108,   108,   108,   108,
     108,   108,   108,   108,   109,   109,   110,   110,   111,   111,
     112,   112,   112,   112,   112,   112,   112,   112,   113,   114,
     115,   115,   116,   116,   116,   116,   116,   116,   116,   116,
     116,   116,   116,   116,   116,   116,   116,   116,   116,   116,
     116,   116,   116,   116,   116,   116,   117,   118,   119,   120,
     122,   123,   124,   121,   125,   126,   127,   128,   128,   128,
     128,   129,   130,   130,   130,   130,   130,   130,   131,   132,
     132,   132,   132,   132,   132,   132,   133,   134,   135,   135,
     135,   135,   136,   137,   137,   137,   137,   138,   139,   139,
     139,   139,   140,   141,   141,   142,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   151,   151,   151,   151,
     151,   152,   152,   152,   152,   153,   153,   153,   154,   154,
     154,   155,   155,   155,   155,   155,   156,   157,   157,   158,
     158,   159,   160,   160,   161,   162,   162,   163,   164,   164,
     165,   166,   166,   167,   168,   169,   170,   170,   171,   171,
     172,   173,   173,   174,   175,   176,   177,   177,   178,   178,
     179,   179,   180,   180,   181,   182,   183,   184,   184,   185,
     186,   187,   187,   188,   188,   189,   189,   190,   190,   191,
     192,   193,   193,   194,   194,   194,   194,   194,   194,   194,
     194,   194,   194,   194,   194
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     1,     1,     2,     4,     4,     6,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     5,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     7,     7,     9,     3,
       0,     0,     0,    12,     3,     3,     3,     1,     1,     1,
       1,     3,     1,     1,     1,     1,     1,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     1,     1,
       1,     1,     3,     1,     1,     1,     1,     3,     1,     1,
       1,     1,     3,     1,     1,     5,    15,     3,     3,     3,
       3,     3,     3,     3,     3,     7,     7,     5,     7,     5,
       5,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     4,     4,     4,     4,     4,     4,     5,     3,     1,
       1,     3,     1,     3,     1,     1,     3,     4,     1,     3,
       3,     1,     3,     3,     4,     4,     3,     3,     1,     1,
       3,     1,     3,     3,     4,     4,     1,     3,     1,     1,
       3,     3,     1,     3,     1,     4,     4,     1,     3,     1,
       4,     1,     3,     1,     1,     3,     3,     1,     3,     9,
       5,     1,     1,     1,     1,     2,     2,     3,     3,     3,
       3,     3,     3,     4,     6
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,     0,     1,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    24,    25,     3,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    23,   202,   201,     0,    26,     7,     8,     0,
       0,     0,     0,     0,     0,     0,     0,    25,     6,     4,
       5,     9,    17,    18,    10,    14,    13,    12,    19,    20,
      11,    21,    22,    16,    15,     0,    30,    31,    33,    34,
      35,    36,    37,    32,     0,   203,   204,     0,     0,     0,
       0,     0,     0,     0,   150,   149,   154,   155,   184,     0,
       0,     0,   176,   179,   178,     0,     0,     0,     0,   169,
     168,     0,     0,     0,   158,     0,   187,   189,     0,     0,
       0,   191,   194,   193,     0,    27,     0,    28,     0,   206,
     205,     0,     0,     0,     0,   152,     0,   146,     0,     0,
       0,     0,     0,     0,     0,   182,     0,     0,   175,     0,
       0,   171,     0,   165,     0,   164,     0,     0,   161,   157,
       0,     0,   186,     0,     0,   197,     0,     0,     0,   190,
     141,   144,   143,   142,   174,   185,   145,    38,     0,     0,
     212,   156,     0,     0,   151,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   148,
      40,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    65,    55,    64,    60,    61,    62,
      63,    56,    57,    58,    59,     0,     0,   207,   208,   209,
     210,   211,     0,   181,   180,   177,   173,     0,   170,   167,
     166,     0,     0,   160,   159,   188,     0,   196,     0,   195,
     192,    29,     0,   213,     0,   153,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   183,   172,   163,   162,   198,     0,     0,
       0,   108,   109,   110,   111,   107,     0,    69,     0,    74,
      75,     0,     0,    96,   118,   117,   119,   120,     0,     0,
      77,    78,    79,    80,    76,   101,    98,    99,   100,    97,
      89,    90,    91,    92,    93,    94,    95,    88,   113,   114,
     112,   103,   104,   105,   106,   102,    87,    82,    83,    84,
      85,    86,    81,     0,   121,   122,   123,   124,    41,     0,
     147,     0,   214,   200,     0,    70,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   115,
       0,     0,     0,     0,     0,     0,    39,     0,     0,     0,
       0,     0,     0,   131,   132,   133,   134,     0,   135,   136,
     137,     0,     0,   138,   139,   140,     0,     0,     0,     0,
      66,    71,     0,    67,     0,     0,   127,     0,   129,     0,
     130,   199,     0,     0,     0,     0,     0,     0,     0,     0,
      68,   125,   126,   128,    72,     0,     0,     0,    73,     0,
       0,     0,   116
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,    18,    19,    20,    74,    21,   226,   199,   200,
     201,   202,   203,   204,   205,   367,   412,   426,   206,   207,
     208,   314,   209,   342,   210,   327,   211,   212,   319,   213,
     335,   214,   295,   215,   330,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   344,   387,   392,   397,    22,    23,
      82,    83,    84,   124,    85,    86,    24,   103,   104,   147,
     148,    25,    26,    97,    98,    99,   140,   100,    27,    28,
      91,    92,    93,   134,   135,    29,    30,   105,   106,    31,
     110,   111,   112,   154,   155,   122,    36,    87
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -137
static const yytype_int16 yypact[] =
{
    -137,    22,  -137,   -86,   104,   -86,   -86,   -60,   -50,   -41,
     -33,   -31,    -5,     9,    51,   -81,  -137,  -137,  -137,   -86,
     -86,   -86,   -24,   -86,   -86,   -86,   -86,    19,   -86,    39,
     -86,   -86,  -137,  -137,  -137,    53,  -137,  -137,  -137,   347,
     -27,   -72,   112,   112,   -73,    53,   157,    61,  -137,  -137,
    -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,
    -137,  -137,  -137,  -137,  -137,    10,  -137,  -137,  -137,  -137,
    -137,  -137,  -137,  -137,    18,  -137,    68,   166,   166,   166,
     166,    52,    57,    81,  -137,  -137,  -137,   245,  -137,    95,
      95,    66,  -137,  -137,  -137,   166,    84,    80,   129,  -137,
    -137,   110,    94,   151,   132,   126,  -137,  -137,   107,   127,
     128,  -137,  -137,  -137,    62,  -137,    53,  -137,   166,  -137,
    -137,   229,   155,   255,   -70,  -137,   210,  -137,   167,   166,
     166,   166,   166,   166,   -38,  -137,   -69,   210,  -137,   160,
     -65,  -137,   210,  -137,   167,  -137,   166,   -22,  -137,  -137,
     210,   210,  -137,   166,   -10,  -137,   280,   -55,   210,  -137,
    -137,  -137,  -137,  -137,  -137,  -137,  -137,   245,   164,   224,
    -137,  -137,   166,    52,  -137,   168,   169,   171,   172,   174,
     180,   185,   187,   189,   191,   203,   226,   227,   250,   251,
     334,   339,   340,   341,   342,   343,   344,   345,   346,  -137,
    -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,
    -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,
    -137,  -137,  -137,  -137,  -137,   348,   216,   108,   108,   214,
     214,   214,    95,  -137,  -137,  -137,  -137,    84,  -137,  -137,
    -137,   223,    94,  -137,   292,  -137,   127,  -137,   166,  -137,
    -137,  -137,   166,  -137,   286,  -137,    73,   349,    53,   350,
     362,   364,   121,    53,   166,   166,   166,   166,   351,   352,
     378,   377,   311,   207,   365,   165,   353,   353,   353,   353,
     210,   166,   167,  -137,  -137,  -137,  -137,  -137,   294,   240,
     166,  -137,  -137,  -137,  -137,  -137,   166,  -137,    53,  -137,
    -137,   166,     6,  -137,   245,   245,   245,   245,   166,   370,
    -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,
    -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,
    -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,
    -137,  -137,  -137,   355,  -137,  -137,  -137,  -137,  -137,    11,
    -137,   166,  -137,   245,   300,  -137,    21,   166,   306,   368,
     369,   371,   372,   373,   166,   312,   166,   374,   166,   245,
     166,   379,   356,    79,   225,   380,   245,    53,    41,    53,
     318,   204,   375,  -137,  -137,  -137,  -137,   381,  -137,  -137,
    -137,   366,   382,  -137,  -137,  -137,   376,   383,   384,   385,
    -137,  -137,   166,  -137,   387,   388,  -137,   389,  -137,   390,
    -137,  -137,   391,    31,   386,   392,   393,   394,    53,   166,
    -137,  -137,  -137,  -137,  -137,   324,   395,   166,  -137,    36,
     166,   209,  -137
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -137,  -137,   154,  -137,  -137,  -137,  -137,  -136,   -79,   188,
    -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,
    -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,
    -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,
    -137,  -137,  -137,  -137,     1,  -137,  -137,  -137,  -137,   396,
    -137,  -137,  -137,  -137,   -66,  -137,   397,  -137,  -137,  -137,
     218,   398,   399,   426,  -137,  -137,  -137,   -89,  -137,   400,
    -137,  -137,  -137,   401,   -36,  -137,   402,  -137,  -137,   403,
    -137,  -137,  -137,   406,   -40,   -84,   -35,   -76
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint16 yytable[] =
{
      65,   119,   120,   121,   123,    94,   113,   141,   240,   357,
     107,   139,    16,    17,   364,   125,    88,    16,    47,   123,
     173,   232,     2,     3,   368,   237,     4,     5,     6,     7,
     102,    89,   156,    90,   419,   246,   174,   234,   167,   430,
      39,   238,   169,     8,     9,    10,    11,    12,    13,    14,
      40,   249,   232,   227,   228,   229,   230,   231,   235,    41,
      75,    76,   241,   239,    77,    78,   233,    42,   242,    43,
     123,   244,   245,    79,    52,    53,    80,   156,    81,   250,
     246,   168,   243,     8,     9,    10,    11,    12,    13,    14,
     291,   292,   293,   294,   247,    44,   254,   129,   130,   131,
     132,   133,   129,   130,   131,   132,   133,   255,   116,    45,
      15,   115,   129,   130,   131,   132,   133,    58,    59,   117,
      16,    17,   129,   130,   131,   132,   133,   129,   130,   131,
     132,   133,   129,   130,   131,   132,   133,    61,    62,    75,
      76,    33,    34,    77,    78,   400,   350,   126,   284,    75,
      76,    46,    79,    77,    78,    80,   137,    32,   127,    37,
      38,   388,    79,   114,   389,   390,   391,   138,   118,    48,
     142,   128,   288,    49,    50,    51,   289,    54,    55,    56,
      57,   143,    60,    88,    63,    64,   302,    95,   304,   305,
     306,   307,    33,    34,    75,    76,   283,   146,    77,    78,
     142,   131,   132,   133,    35,   349,   287,    79,    75,    76,
     153,   145,    77,    78,   353,    95,   151,    96,   158,   144,
     354,    79,   150,   297,   301,   356,   175,   152,   303,   159,
     153,   336,   358,   337,   338,   339,   340,   341,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   149,    75,    76,   225,   190,    77,    78,   171,
     108,   191,   109,   355,   236,   251,    79,   328,   329,   192,
     256,   257,   193,   258,   259,   365,   260,   194,   345,   346,
     347,   369,   261,   195,   196,   197,   198,   262,   376,   263,
     378,   264,   380,   265,   381,   129,   130,   131,   132,   133,
     129,   130,   131,   132,   133,   266,   282,   393,   403,   133,
     394,   395,   396,   432,   252,   129,   130,   131,   132,   133,
     129,   130,   131,   132,   133,   253,   413,   285,   267,   268,
     170,   129,   130,   131,   132,   133,   129,   130,   131,   132,
     133,   352,   399,   425,   401,   172,   129,   130,   131,   132,
     133,   429,   269,   270,   431,    66,    67,    68,    69,    70,
      71,    72,    73,   320,   321,   322,   323,   324,   325,   326,
     248,   129,   130,   131,   132,   133,   290,   129,   130,   131,
     132,   133,   280,   424,   351,   129,   130,   131,   132,   133,
     366,   129,   130,   131,   132,   133,   370,   129,   130,   131,
     132,   133,   377,   129,   130,   131,   132,   133,   402,   129,
     130,   131,   132,   133,   427,   129,   130,   131,   132,   133,
     310,   311,   312,   313,   315,   316,   317,   318,   331,   332,
     333,   334,   360,   361,   362,   363,   271,   383,   384,   385,
     386,   272,   273,   274,   275,   276,   277,   278,   279,   299,
     281,   300,   296,   298,   308,   309,   343,   359,   371,   372,
     286,   373,   374,   375,   379,   404,   382,   398,   348,   101,
     406,   405,   407,   409,   414,   415,   416,   417,     0,     0,
     408,   418,     0,     0,     0,     0,     0,     0,   410,   411,
     420,   136,     0,     0,     0,     0,   421,   422,   423,   428,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     160,   161,   162,   163,   164,   157,   165,   166
};

static const yytype_int16 yycheck[] =
{
      35,    77,    78,    79,    80,    41,    46,    96,   144,     3,
      45,    95,    98,    99,     3,    81,    88,    98,    99,    95,
      90,    90,     0,     1,     3,    90,     4,     5,     6,     7,
     103,   103,   108,   105,     3,    90,   106,   106,   114,     3,
     100,   106,   118,    21,    22,    23,    24,    25,    26,    27,
     100,   106,    90,   129,   130,   131,   132,   133,   137,   100,
      87,    88,   146,   142,    91,    92,   104,   100,    90,   100,
     146,   150,   151,   100,    98,    99,   103,   153,   105,   158,
      90,   116,   104,    21,    22,    23,    24,    25,    26,    27,
      17,    18,    19,    20,   104,   100,   172,    91,    92,    93,
      94,    95,    91,    92,    93,    94,    95,   173,    90,   100,
      88,   101,    91,    92,    93,    94,    95,    98,    99,   101,
      98,    99,    91,    92,    93,    94,    95,    91,    92,    93,
      94,    95,    91,    92,    93,    94,    95,    98,    99,    87,
      88,    88,    89,    91,    92,   104,   282,    90,   237,    87,
      88,   100,   100,    91,    92,   103,    90,     3,   101,     5,
       6,    82,   100,   102,    85,    86,    87,   101,   100,    15,
      90,    90,   248,    19,    20,    21,   252,    23,    24,    25,
      26,   101,    28,    88,    30,    31,   262,   103,   264,   265,
     266,   267,    88,    89,    87,    88,   232,   103,    91,    92,
      90,    93,    94,    95,   100,   281,   246,   100,    87,    88,
     103,   101,    91,    92,   290,   103,    90,   105,    90,    90,
     296,   100,    90,   258,   103,   301,    16,   101,   263,   101,
     103,    66,   308,    68,    69,    70,    71,    72,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,   101,    87,    88,    88,    46,    91,    92,   104,
     103,    51,   105,   298,   104,   101,   100,    60,    61,    59,
     102,   102,    62,   102,   102,   351,   102,    67,   277,   278,
     279,   357,   102,    73,    74,    75,    76,   102,   364,   102,
     366,   102,   368,   102,   370,    91,    92,    93,    94,    95,
      91,    92,    93,    94,    95,   102,    90,    82,   104,    95,
      85,    86,    87,   104,    90,    91,    92,    93,    94,    95,
      91,    92,    93,    94,    95,   101,   402,   104,   102,   102,
     101,    91,    92,    93,    94,    95,    91,    92,    93,    94,
      95,   101,   377,   419,   379,    90,    91,    92,    93,    94,
      95,   427,   102,   102,   430,     8,     9,    10,    11,    12,
      13,    14,    15,    52,    53,    54,    55,    56,    57,    58,
      90,    91,    92,    93,    94,    95,    90,    91,    92,    93,
      94,    95,    90,   418,    90,    91,    92,    93,    94,    95,
      90,    91,    92,    93,    94,    95,    90,    91,    92,    93,
      94,    95,    90,    91,    92,    93,    94,    95,    90,    91,
      92,    93,    94,    95,    90,    91,    92,    93,    94,    95,
      42,    43,    44,    45,    47,    48,    49,    50,    63,    64,
      65,    66,    77,    78,    79,    80,   102,    81,    82,    83,
      84,   102,   102,   102,   102,   102,   102,   102,   102,    87,
     102,    87,   103,   103,   103,   103,   103,    87,    90,    90,
     242,    90,    90,    90,    90,    90,    87,    87,   280,    43,
     104,    90,    90,    90,    87,    87,    87,    87,    -1,    -1,
     104,    90,    -1,    -1,    -1,    -1,    -1,    -1,   104,   104,
     104,    90,    -1,    -1,    -1,    -1,   104,   104,   104,   104,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     114,   114,   114,   114,   114,   109,   114,   114
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,   108,     0,     1,     4,     5,     6,     7,    21,    22,
      23,    24,    25,    26,    27,    88,    98,    99,   109,   110,
     111,   113,   155,   156,   163,   168,   169,   175,   176,   182,
     183,   186,   109,    88,    89,   100,   193,   109,   109,   100,
     100,   100,   100,   100,   100,   100,   100,    99,   109,   109,
     109,   109,    98,    99,   109,   109,   109,   109,    98,    99,
     109,    98,    99,   109,   109,   193,     8,     9,    10,    11,
      12,    13,    14,    15,   112,    87,    88,    91,    92,   100,
     103,   105,   157,   158,   159,   161,   162,   194,    88,   103,
     105,   177,   178,   179,   181,   103,   105,   170,   171,   172,
     174,   170,   103,   164,   165,   184,   185,   193,   103,   105,
     187,   188,   189,   191,   102,   101,    90,   101,   100,   194,
     194,   194,   192,   194,   160,   161,    90,   101,    90,    91,
      92,    93,    94,    95,   180,   181,   180,    90,   101,   192,
     173,   174,    90,   101,    90,   101,   103,   166,   167,   101,
      90,    90,   101,   103,   190,   191,   194,   190,    90,   101,
     156,   163,   168,   169,   176,   183,   186,   194,   193,   194,
     101,   104,    90,    90,   106,    16,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      46,    51,    59,    62,    67,    73,    74,    75,    76,   115,
     116,   117,   118,   119,   120,   121,   125,   126,   127,   129,
     131,   133,   134,   136,   138,   140,   142,   143,   144,   145,
     146,   147,   148,   149,   150,    88,   114,   194,   194,   194,
     194,   194,    90,   104,   106,   115,   104,    90,   106,   115,
     114,   192,    90,   104,   115,   115,    90,   104,    90,   106,
     115,   101,    90,   101,   194,   161,   102,   102,   102,   102,
     102,   102,   102,   102,   102,   102,   102,   102,   102,   102,
     102,   102,   102,   102,   102,   102,   102,   102,   102,   102,
      90,   102,    90,   181,   174,   104,   167,   191,   194,   194,
      90,    17,    18,    19,    20,   139,   103,   193,   103,    87,
      87,   103,   194,   193,   194,   194,   194,   194,   103,   103,
      42,    43,    44,    45,   128,    47,    48,    49,    50,   135,
      52,    53,    54,    55,    56,    57,    58,   132,    60,    61,
     141,    63,    64,    65,    66,   137,    66,    68,    69,    70,
      71,    72,   130,   103,   151,   151,   151,   151,   116,   194,
     114,    90,   101,   194,   194,   193,   194,     3,   194,    87,
      77,    78,    79,    80,     3,   194,    90,   122,     3,   194,
      90,    90,    90,    90,    90,    90,   194,    90,   194,    90,
     194,   194,    87,    81,    82,    83,    84,   152,    82,    85,
      86,    87,   153,    82,    85,    86,    87,   154,    87,   193,
     104,   193,    90,   104,    90,    90,   104,    90,   104,    90,
     104,   104,   123,   194,    87,    87,    87,    87,    90,     3,
     104,   104,   104,   104,   193,   194,   124,    90,   104,   194,
       3,   194,   104
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 79 "grammar.y"
    {	PRINTF(("empty statment 1\n")); ;}
    break;

  case 3:

/* Line 1455 of yacc.c  */
#line 80 "grammar.y"
    {	PRINTF(("empty statment 2\n")); ;}
    break;

  case 4:

/* Line 1455 of yacc.c  */
#line 81 "grammar.y"
    {	read_from_file((yyvsp[(2) - (3)].str)); return PP_READ; ;}
    break;

  case 5:

/* Line 1455 of yacc.c  */
#line 82 "grammar.y"
    {	save_graph_to_file((yyvsp[(2) - (3)].sgd)); return PP_SAVEGRAPH; ;}
    break;

  case 6:

/* Line 1455 of yacc.c  */
#line 83 "grammar.y"
    {	show_sym((yyvsp[(2) - (3)].str)); return PP_SHOW; ;}
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 84 "grammar.y"
    {	dump_symtab(); return PP_DUMP; ;}
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 85 "grammar.y"
    {	re_start(); return PP_RESTART; ;}
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 86 "grammar.y"
    {	assign_sym((yyvsp[(2) - (3)].e)); return PP_ASGN; ;}
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 87 "grammar.y"
    {	return PP_PLOT; ;}
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 88 "grammar.y"
    {	return PP_DISPLAY; ;}
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 89 "grammar.y"
    {	return PP_SPACECURVE; ;}
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 90 "grammar.y"
    {	return PP_TUBEPLOT; ;}
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 91 "grammar.y"
    {	return PP_POLYGONPLOT; ;}
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 92 "grammar.y"
    {	return PP_TEXTPLOT; ;}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 93 "grammar.y"
    {	return PP_DATAPLOT; ;}
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 94 "grammar.y"
    {	return PP_PLOT_SAVE_SHOW; ;}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 95 "grammar.y"
    {	return PP_PLOT_SAVE; ;}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 96 "grammar.y"
    {	return PP_DISP_SAVE_SHOW; ;}
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 97 "grammar.y"
    {	return PP_DISP_SAVE; ;}
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 98 "grammar.y"
    {	return PP_DATAPLOT_SAVE_SHOW; ;}
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 99 "grammar.y"
    {	return PP_DATAPLOT_SAVE; ;}
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 100 "grammar.y"
    {	yyerrok; return PP_ERROR; ;}
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 107 "grammar.y"
    { (yyval.str)=(yyvsp[(2) - (2)].str); ;}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 108 "grammar.y"
    { (yyval.str)=(yyvsp[(3) - (4)].str); ;}
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 112 "grammar.y"
    {
				(yyval.sgd) = (SavegraphData *)malloc(sizeof(SavegraphData));
				(yyval.sgd)->fmt = (yyvsp[(3) - (4)].fmt);
				(yyval.sgd)->file = NULL; ;}
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 116 "grammar.y"
    {
				(yyval.sgd) = (SavegraphData *)malloc(sizeof(SavegraphData));
				(yyval.sgd)->fmt = (yyvsp[(3) - (6)].fmt);
				(yyval.sgd)->file = (yyvsp[(5) - (6)].str); ;}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 122 "grammar.y"
    { (yyval.fmt) = JPEG_FORMAT; ;}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 123 "grammar.y"
    { (yyval.fmt) = TIFF_FORMAT; ;}
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 124 "grammar.y"
    { (yyval.fmt) = PNG_FORMAT; ;}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 125 "grammar.y"
    { (yyval.fmt) = PPM3_FORMAT; ;}
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 126 "grammar.y"
    { (yyval.fmt) = PPM6_FORMAT; ;}
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 127 "grammar.y"
    { (yyval.fmt) = PS_FORMAT; ;}
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 128 "grammar.y"
    { (yyval.fmt) = CPS_FORMAT; ;}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 129 "grammar.y"
    { (yyval.fmt) = VPS_FORMAT; ;}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 132 "grammar.y"
    {
			(yyvsp[(4) - (4)].e)->lval = (yyvsp[(1) - (4)].str);
			(yyvsp[(4) - (4)].e)->fp = NULL;
			(yyval.e) = (yyvsp[(4) - (4)].e); ;}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 138 "grammar.y"
    {
			(yyval.rspec) = (Range *)malloc(sizeof(Range));
			(yyval.rspec)->id=(yyvsp[(1) - (5)].str);
			(yyval.rspec)->lo=(yyvsp[(3) - (5)].e);
			(yyval.rspec)->hi=(yyvsp[(5) - (5)].e); ;}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 175 "grammar.y"
    {
			dg_attribs->xgrid=(yyvsp[(4) - (7)].e);
			dg_attribs->ygrid=(yyvsp[(6) - (7)].e); ;}
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 180 "grammar.y"
    {
			dg_attribs->view_longitude=(yyvsp[(4) - (7)].e);
			dg_attribs->view_colatitude=(yyvsp[(6) - (7)].e); ;}
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 185 "grammar.y"
    {
			dg_attribs->xticks = atoi((yyvsp[(4) - (9)].str));
			dg_attribs->yticks = atoi((yyvsp[(6) - (9)].str));
			dg_attribs->zticks = atoi((yyvsp[(8) - (9)].str)); ;}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 192 "grammar.y"
    { dg_attribs->title=(yyvsp[(3) - (3)].str); ;}
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 196 "grammar.y"
    { dg_attribs->xlabel=(yyvsp[(4) - (4)].str); ;}
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 197 "grammar.y"
    { dg_attribs->ylabel=(yyvsp[(7) - (7)].str); ;}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 198 "grammar.y"
    { dg_attribs->zlabel=(yyvsp[(10) - (10)].str); ;}
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 201 "grammar.y"
    {
			int thickness = atoi((yyvsp[(3) - (3)].str));
			/* thickness should be betweem 0 and 10 */
			thickness = MAX(0, thickness);
			thickness = MIN(10, thickness);
			/* convert to dynagraph's internal representation */
			if (thickness==0)
				dg_attribs->thickness = DEFAULT_THICKNESS;
			else
				dg_attribs->thickness = (1<<thickness);
			dg_attribs->thickness |= locked; ;}
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 214 "grammar.y"
    {
			int pointsize = atoi((yyvsp[(3) - (3)].str));
			/* pointsize should be betweem 0 and 10 */
			pointsize = MAX(0, pointsize);
			pointsize = MIN(10, pointsize);
			/* convert to dynagraph's internal representation */
			if (pointsize==0)
				dg_attribs->pointsize = DEFAULT_POINTSIZE;
			else
				dg_attribs->pointsize = (1<<pointsize);
			dg_attribs->pointsize |= locked; ;}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 230 "grammar.y"
    { dg_attribs->coords=CARTESIAN; ;}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 231 "grammar.y"
    { dg_attribs->coords=CYLINDRICAL; ;}
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 232 "grammar.y"
    { dg_attribs->coords=Z_CYLINDRICAL; ;}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 233 "grammar.y"
    { dg_attribs->coords=SPHERICAL; ;}
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 240 "grammar.y"
    { dg_attribs->shading=XYZSHADING|locked; ;}
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 241 "grammar.y"
    { dg_attribs->shading=XYSHADING|locked; ;}
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 242 "grammar.y"
    { dg_attribs->shading=ZSHADING|locked; ;}
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 243 "grammar.y"
    { dg_attribs->shading=ZGRAYSCALE|locked; ;}
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 244 "grammar.y"
    { dg_attribs->shading=ZHUE|locked; ;}
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 245 "grammar.y"
    { dg_attribs->shading=NOSHADING|locked; ;}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 251 "grammar.y"
    { dg_attribs->style=POINT|locked; ;}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 252 "grammar.y"
    { dg_attribs->style=HIDDEN|locked; ;}
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 253 "grammar.y"
    { dg_attribs->style=PATCH|locked; ;}
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 254 "grammar.y"
    { dg_attribs->style=WIREFRAME|locked; ;}
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 255 "grammar.y"
    { dg_attribs->style=CONTOUR|locked; ;}
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 256 "grammar.y"
    { dg_attribs->style=PATCHNOGRID|locked; ;}
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 257 "grammar.y"
    { dg_attribs->style=PATCHCONTOUR|locked; ;}
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 260 "grammar.y"
    { dg_attribs->color=(yyvsp[(3) - (3)].str); ;}
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 266 "grammar.y"
    { dg_attribs->gridstyle=XY_GRIDLINES|locked; ;}
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 267 "grammar.y"
    { dg_attribs->gridstyle=X_GRIDLINES|locked; ;}
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 268 "grammar.y"
    { dg_attribs->gridstyle=Y_GRIDLINES|locked; ;}
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 269 "grammar.y"
    { dg_attribs->gridstyle=TRIANGULAR_GRIDLINES|locked; ;}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 275 "grammar.y"
    { dg_attribs->axes=BOXED|locked; ;}
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 276 "grammar.y"
    { dg_attribs->axes=NORMAL|locked; ;}
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 277 "grammar.y"
    { dg_attribs->axes=FRAME|locked; ;}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 278 "grammar.y"
    { dg_attribs->axes=NOAXES|locked; ;}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 284 "grammar.y"
    { dg_plots->textalign |= ALIGN_LEFT; ;}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 285 "grammar.y"
    { dg_plots->textalign |= ALIGN_RIGHT; ;}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 286 "grammar.y"
    { dg_plots->textalign |= ALIGN_ABOVE; ;}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 287 "grammar.y"
    { dg_plots->textalign |= ALIGN_BELOW; ;}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 294 "grammar.y"
    { dg_attribs->scaling=CONSTRAINED|locked; ;}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 296 "grammar.y"
    { dg_attribs->scaling=UNCONSTRAINED|locked; ;}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 299 "grammar.y"
    {
			dg_attribs->z_viewmin = (yyvsp[(3) - (5)].e);
			dg_attribs->z_viewmax = (yyvsp[(5) - (5)].e); ;}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 302 "grammar.y"
    {
			dg_attribs->x_viewmin = (yyvsp[(4) - (15)].e);
			dg_attribs->x_viewmax = (yyvsp[(6) - (15)].e);
			dg_attribs->y_viewmin = (yyvsp[(8) - (15)].e);
			dg_attribs->y_viewmax = (yyvsp[(10) - (15)].e);
			dg_attribs->z_viewmin = (yyvsp[(12) - (15)].e);
			dg_attribs->z_viewmax = (yyvsp[(14) - (15)].e); ;}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 311 "grammar.y"
    { dg_attribs->num_points=(yyvsp[(3) - (3)].e); ;}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 314 "grammar.y"
    { dg_attribs->num_contours=(yyvsp[(3) - (3)].e); ;}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 317 "grammar.y"
    { dg_attribs->tube_points=(yyvsp[(3) - (3)].e); ;}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 320 "grammar.y"
    { dg_attribs->tube_radius=(yyvsp[(3) - (3)].e); ;}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 324 "grammar.y"
    { dg_attribs->axesfont = (yyvsp[(3) - (3)].fspec)|locked; ;}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 328 "grammar.y"
    { dg_attribs->font = (yyvsp[(3) - (3)].fspec)|locked; ;}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 332 "grammar.y"
    { dg_attribs->labelfont = (yyvsp[(3) - (3)].fspec)|locked; ;}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 336 "grammar.y"
    { dg_attribs->titlefont = (yyvsp[(3) - (3)].fspec)|locked; ;}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 339 "grammar.y"
    {
			(yyval.fspec) = TIMES + (yyvsp[(4) - (7)].fspec) + MIN(MAX(1,atoi((yyvsp[(6) - (7)].str))), 0177); ;}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 341 "grammar.y"
    {
			(yyval.fspec) = COURIER + (yyvsp[(4) - (7)].fspec) + MIN(MAX(1,atoi((yyvsp[(6) - (7)].str))), 0177); ;}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 343 "grammar.y"
    {
			(yyval.fspec) = COURIER + ROMAN + MIN(MAX(1,atoi((yyvsp[(4) - (5)].str))), 0177); ;}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 345 "grammar.y"
    {
			(yyval.fspec) = HELVETICA + (yyvsp[(4) - (7)].fspec) + MIN(MAX(1,atoi((yyvsp[(6) - (7)].str))), 0177); ;}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 347 "grammar.y"
    {
			(yyval.fspec) = HELVETICA + ROMAN + MIN(MAX(1,atoi((yyvsp[(4) - (5)].str))), 0177); ;}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 349 "grammar.y"
    {
			(yyval.fspec) = SYMBOL + ROMAN + MIN(MAX(1,atoi((yyvsp[(4) - (5)].str))), 0177); ;}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 353 "grammar.y"
    { (yyval.fspec) = ROMAN; ;}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 354 "grammar.y"
    { (yyval.fspec) = BOLD; ;}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 355 "grammar.y"
    { (yyval.fspec) = ITALIC; ;}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 356 "grammar.y"
    { (yyval.fspec) = BOLDITALIC; ;}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 359 "grammar.y"
    { (yyval.fspec) = BOLD; ;}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 360 "grammar.y"
    { (yyval.fspec) = OBLIQUE; ;}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 361 "grammar.y"
    { (yyval.fspec) = BOLDOBLIQUE; ;}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 364 "grammar.y"
    { (yyval.fspec) = BOLD; ;}
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 365 "grammar.y"
    { (yyval.fspec) = OBLIQUE; ;}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 366 "grammar.y"
    { (yyval.fspec) = BOLDOBLIQUE; ;}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 369 "grammar.y"
    { dg_attribs->id = (yyvsp[(1) - (4)].str); ;}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 370 "grammar.y"
    { dg_attribs->id = (yyvsp[(1) - (4)].str); ;}
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 371 "grammar.y"
    { dg_attribs->id = (yyvsp[(1) - (4)].str); ;}
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 372 "grammar.y"
    { dg_attribs->id = (yyvsp[(1) - (4)].str); ;}
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 373 "grammar.y"
    { dg_attribs->id = (yyvsp[(1) - (4)].str); ;}
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 379 "grammar.y"
    {
			dg_attribs->xrange=(yyvsp[(3) - (5)].rspec);
			dg_attribs->yrange=(yyvsp[(5) - (5)].rspec); ;}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 385 "grammar.y"
    { /* empty */ ;}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 386 "grammar.y"
    { /* empty */ ;}
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 392 "grammar.y"
    { /* empty */ ;}
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 393 "grammar.y"
    {
			Plot3D *p, *q=NULL;
			for (p=dg_plots; p!=NULL; p=p->fp)
				q=p;
			p = create_plot3d_structure();
			p->attr = dg_attribs;
			p->type = (yyvsp[(3) - (3)].e3)->u==NULL ?  FUNCTION_PLOT : PARAM_PLOT;
			p->parg=(yyvsp[(3) - (3)].e3);
			q->fp = p;
			p->bp = q; ;}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 405 "grammar.y"
    {
			if (dg_plots==NULL) {
				dg_plots = create_plot3d_structure();
				dg_attribs = create_plot3d_attribs_structure();
				dg_plots->attr = dg_attribs;
				dg_plots->type = (yyvsp[(1) - (1)].e3)->u==NULL ?
					FUNCTION_PLOT : PARAM_PLOT;
				dg_plots->parg=(yyvsp[(1) - (1)].e3);
			}
			(yyval.e3)=(yyvsp[(1) - (1)].e3); ;}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 417 "grammar.y"
    {
			(yyval.e3)=(Expr3 *)malloc(sizeof(Expr3));
			(yyval.e3)->u=NULL;
			(yyval.e3)->v=NULL;
			(yyval.e3)->w=(yyvsp[(1) - (1)].e); ;}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 423 "grammar.y"
    { (yyval.e3)=(yyvsp[(2) - (3)].e3); ;}
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 435 "grammar.y"
    {
				dg_plots = create_plot3d_structure();
				dg_attribs = create_plot3d_attribs_structure();
				dg_plots->attr = dg_attribs;
				dg_plots->type = POLYGON_PLOT;
				dg_plots->polygon_vertices = (yyvsp[(2) - (3)].pvp); ;}
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 443 "grammar.y"
    { (yyval.pvp) = dg_vertex_tail =  (yyvsp[(1) - (1)].pvp); ;}
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 444 "grammar.y"
    {
				dg_vertex_tail->fp = (yyvsp[(3) - (3)].pvp);
				dg_vertex_tail = (yyvsp[(3) - (3)].pvp);
				(yyval.pvp) = (yyvsp[(1) - (3)].pvp); ;}
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 450 "grammar.y"
    {
				(yyval.pvp) = (PolygonVertex*)malloc(sizeof(PolygonVertex));
				(yyval.pvp)->v = (yyvsp[(2) - (3)].e3);
				(yyval.pvp)->fp = NULL; ;}
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 456 "grammar.y"
    {
				Plot3D *p;
				for (p=dg_plots; p!=NULL; p=p->fp)
					p->type = TUBE_PLOT; ;}
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 465 "grammar.y"
    { dg_attribs->xrange=(yyvsp[(3) - (3)].rspec); ;}
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 469 "grammar.y"
    { /* empty */ ;}
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 470 "grammar.y"
    { /* empty */ ;}
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 476 "grammar.y"
    { /* empty */ ;}
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 477 "grammar.y"
    {
			Plot3D *p, *q=NULL;
			for (p=dg_plots; p!=NULL; p=p->fp)
				q=p;
			p = create_plot3d_structure();
			p->attr = dg_attribs;
			p->type = CURVE_PLOT;
			p->parg=(yyvsp[(3) - (3)].e3);
			q->fp = p;
			p->bp = q; ;}
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 489 "grammar.y"
    {
			if (dg_plots==NULL) {
				dg_plots = create_plot3d_structure();
				dg_attribs = create_plot3d_attribs_structure();
				dg_plots->attr = dg_attribs;
				dg_plots->type = CURVE_PLOT;
				dg_plots->parg=(yyvsp[(2) - (3)].e3);
			}
			(yyval.e3)=(yyvsp[(2) - (3)].e3); ;}
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 500 "grammar.y"
    { dg_attribs->id = (yyvsp[(1) - (4)].str); ;}
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 522 "grammar.y"
    {
			if (dg_attribs==NULL) {
				dg_attribs = create_plot3d_attribs_structure();
				dg_dispargs=(yyvsp[(1) - (1)].str);
			} else
				dg_dispargs = catargs(dg_dispargs, (yyvsp[(1) - (1)].str)); ;}
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 530 "grammar.y"
    { dg_attribs->id = (yyvsp[(1) - (4)].str); ;}
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 541 "grammar.y"
    {
			dg_attribs = create_plot3d_attribs_structure();
			dg_dispargs=(yyvsp[(1) - (1)].str); ;}
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 565 "grammar.y"
    {
			if (dg_plots==NULL) {
				dg_plots = create_plot3d_structure();
				dg_attribs = create_plot3d_attribs_structure();
				dg_plots->attr = dg_attribs;
				dg_plots->type = TEXT_PLOT;
				dg_plots->textobj = create_textobject();
			} else {
				TextObj *p = create_textobject();
				p->fp = dg_plots->textobj;
				dg_plots->textobj = p;
			}
			dg_plots->textobj->xspec = (yyvsp[(2) - (9)].e);
			dg_plots->textobj->yspec = (yyvsp[(4) - (9)].e);
			dg_plots->textobj->zspec = (yyvsp[(6) - (9)].e);
			dg_plots->textobj->text = (yyvsp[(8) - (9)].str); ;}
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 583 "grammar.y"
    {
			(yyval.e3)=(Expr3 *)malloc(sizeof(Expr3));
			(yyval.e3)->u=(yyvsp[(1) - (5)].e);
			(yyval.e3)->v=(yyvsp[(3) - (5)].e);
			(yyval.e3)->w=(yyvsp[(5) - (5)].e); ;}
    break;

  case 201:

/* Line 1455 of yacc.c  */
#line 591 "grammar.y"
    { (yyval.str)=(yyvsp[(1) - (1)].str); ;}
    break;

  case 202:

/* Line 1455 of yacc.c  */
#line 592 "grammar.y"
    { (yyval.str)=(yyvsp[(1) - (1)].str); ;}
    break;

  case 203:

/* Line 1455 of yacc.c  */
#line 596 "grammar.y"
    { (yyval.e)=merge_expr0((yyvsp[(1) - (1)].str)); ;}
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 597 "grammar.y"
    { (yyval.e)=merge_expr0((yyvsp[(1) - (1)].str)); ;}
    break;

  case 205:

/* Line 1455 of yacc.c  */
#line 598 "grammar.y"
    { (yyval.e)=merge_expr1((yyvsp[(2) - (2)].e), 0); ;}
    break;

  case 206:

/* Line 1455 of yacc.c  */
#line 599 "grammar.y"
    { (yyval.e)=merge_expr1((yyvsp[(2) - (2)].e), 1); ;}
    break;

  case 207:

/* Line 1455 of yacc.c  */
#line 600 "grammar.y"
    { (yyval.e)=merge_expr2((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e), '+'); ;}
    break;

  case 208:

/* Line 1455 of yacc.c  */
#line 601 "grammar.y"
    { (yyval.e)=merge_expr2((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e), '-'); ;}
    break;

  case 209:

/* Line 1455 of yacc.c  */
#line 602 "grammar.y"
    { (yyval.e)=merge_expr2((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e), '*'); ;}
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 603 "grammar.y"
    { (yyval.e)=merge_expr2((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e), '/'); ;}
    break;

  case 211:

/* Line 1455 of yacc.c  */
#line 604 "grammar.y"
    { (yyval.e)=merge_expr2((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e), '^'); ;}
    break;

  case 212:

/* Line 1455 of yacc.c  */
#line 605 "grammar.y"
    { (yyval.e)=merge_expr1((yyvsp[(2) - (3)].e), 2); ;}
    break;

  case 213:

/* Line 1455 of yacc.c  */
#line 606 "grammar.y"
    { (yyval.e)=merge_expr3((yyvsp[(3) - (4)].e), (yyvsp[(1) - (4)].str)); ;}
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 607 "grammar.y"
    { (yyval.e)=merge_expr4((yyvsp[(3) - (6)].e), (yyvsp[(5) - (6)].e), (yyvsp[(1) - (6)].str)); ;}
    break;



/* Line 1455 of yacc.c  */
#line 3055 "grammar.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 610 "grammar.y"
	/* end of grammar */


static Expr *merge_expr0(char *s)
{
	Expr *e;
	e = malloc(sizeof(Expr));
	e->lval = NULL;
	e->rval = s;
	e->fp = NULL;
	return e;
}

static Expr *merge_expr1(Expr *e, short int type)
{
	char *s;

	if (type==0) {				/* expr = - expr */
		s = malloc(strlen(e->rval)+2);
		sprintf(s, "%c%s", '-', e->rval);
	} else if (type==1) {			/* expr = + expr */
		s = malloc(strlen(e->rval)+2);
		sprintf(s, "%c%s", '+', e->rval);
	} else /* type==2 */ {			/* expr = ( expr ) */
		s = malloc(strlen(e->rval)+3);
		sprintf(s, "(%s)", e->rval);
	}
	free(e->rval);
	e->rval = s;
	return e;
}

static Expr *merge_expr2(Expr *a, Expr *b, char op)
{
	Expr *e;

	e = malloc(sizeof(Expr));
	e->lval = NULL;
	e->rval = malloc(strlen(a->rval)+strlen(b->rval)+2);
	sprintf(e->rval, "%s%c%s", a->rval, op, b->rval);
	e->fp = NULL;
	
	free_expr(a);
	free_expr(b);

	return e;
}

static Expr *merge_expr3(Expr *e, char *id)
{
	char *s;

	s = malloc(strlen(e->rval)+strlen(id)+3);
	sprintf(s, "%s(%s)", id, e->rval);
	free(e->rval);
	e->rval = s;
	free(id);
	return e;
}

static Expr *merge_expr4(Expr *e1, Expr *e2, char *id)
{
	char *s;

	s = malloc(strlen(e1->rval)+strlen(e2->rval)+strlen(id)+4);
	sprintf(s, "%s(%s,%s)", id, e1->rval,e2->rval);
	free(e1->rval);
	e1->rval = s;
	free_expr(e2);
	free(id);
	return e1;
}


/* crates a new comma-separated string from strings a and b */
static char *catargs(char *a, char *b)
{
	char *s;

	s = malloc(strlen(a)+strlen(b)+2);
	sprintf(s, "%s,%s", a, b);
	free(a);
	free(b);
	return s;
}

static int yyerror(char *s)
{
	show_parse_error(); 
	return -2;	/* not used */
}

